----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:09:25 05/09/2010 
-- Design Name: 
-- Module Name:    test_G_sitcp - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity test_GST_sub is
    Port ( clk : in  STD_LOGIC;
	tx_wd : out std_logic_vector(7 downto 0);
	tx_we : out  STD_LOGIC;
	tx_afull : in  STD_LOGIC;
	rx_rd : in std_logic_vector(7 downto 0);
	rx_rv : in  STD_LOGIC;
	rx_re : out  STD_LOGIC;
	rx_empty : in  STD_LOGIC;
	close_req : in  STD_LOGIC;
	close_ack : out  STD_LOGIC;
	active : in  STD_LOGIC);
end test_GST_sub;

architecture Behavioral of test_GST_sub is
	signal hl_flag, hlr_flag : STD_LOGIC;
	signal test_ct : STD_LOGIC_VECTOR(15 downto 0);
begin
process (CLK) 
begin
if CLK='1' and CLK'event then
	if active='1' then
		if close_req='1' then
			close_ack <= '1';
		else
			close_ack <= '0';
			if tx_afull='0' then
				tx_we <= '1';
				hl_flag <= not hl_flag;
				if hl_flag='0' then
					tx_wd <= test_ct(15 downto 8);
				else
					tx_wd <= test_ct(7 downto 0);
					test_ct <= test_ct+1;
				end if;
			else
				tx_we <= '0';
			end if;
			if rx_empty='0' then
				rx_re <= '1';
				if rx_rv='1' then
					hlr_flag <= not hlr_flag;
					if hlr_flag='0' then
						test_ct(15 downto 8) <= rx_rd;
					else
						test_ct(7 downto 0) <= rx_rd;
					end if;
				end if;
			else
				rx_re <= '0';
			end if;
		end if;
	else
		close_ack <= '0';
		tx_we <= '0';
		rx_re <= '0';
		hl_flag <= '0';
		hlr_flag <= '0';
		test_ct <= (others=>'0');
	end if;
end if;
end process;
end Behavioral;

