----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    07:52:11 05/13/2010 
-- Design Name: 
-- Module Name:    test_WSiT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity test_WSiT is
    Port ( clkp : in  STD_LOGIC;
	MACCLK : out  STD_LOGIC;	--25MHz
	SW_RST : in  STD_LOGIC;
--	// EEPROM
	EEPROM_CS :		out STD_LOGIC;--	,	// out	: Chip select
	EEPROM_SK :		out STD_LOGIC;--	,	// out	: Serial data clock
	EEPROM_DI :		out STD_LOGIC;--	,	// out	: Serial write data
	EEPROM_DO :		inout STD_LOGIC;--	,	// in	: Serial read data
--	// MII interface
--	GMII_1000M :		in STD_LOGIC;--// in	: GMII mode (0:MII, 1:GMII)
	GMII_RSTn :		out STD_LOGIC;--// in type miss	: PHY reset
	LED_1000Mn :		in STD_LOGIC;--// in	: 1000M mode
--		// TX
	GMII_GTXCLK :		out STD_LOGIC;--// out	: GTx clock(125MHz)
	GMII_TX_CLK :		in STD_LOGIC;--// in	: Tx clock(2.5 or 25MHz)
	GMII_TX_EN :		out STD_LOGIC;--// out	: Tx enable
	GMII_TXD :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Tx data[7:0]
	GMII_TX_ER :		out STD_LOGIC;--// out	: TX error
--		// RX
	GMII_RX_CLK :		in STD_LOGIC;--// in	: Rx clock(2.5 or 25MHz)
	GMII_RX_DV :		in STD_LOGIC;--// in	: Rx data valid
	GMII_RXD :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Rx data[7:0]
	GMII_RX_ER :		in STD_LOGIC;--// in	: Rx error
	GMII_CRS :		in STD_LOGIC;--// in	: Carrier sense
	GMII_COL :		in STD_LOGIC;--// in	: Collision detected
--		// Management IF
	GMII_MDC :		out STD_LOGIC;--// out	: Clock for MDIO
	GMII_MDIO :		inout STD_LOGIC;--// in	: Data

	led : out  STD_LOGIC_VECTOR(2 downto 0));
end test_WSiT;

architecture Behavioral of test_WSiT is
component WRAP_SiTCP_GMII_XC4_32K
Port (
	CLK :		in STD_LOGIC;--// in	: System clock
	RST :		in STD_LOGIC;--// in	: System reset
--	// Configuration parameters
	FORCE_DEFAULTn :	in STD_LOGIC;--// in	: Load default values
	EXT_IP_ADDR :	in STD_LOGIC_VECTOR(31 downto 0);--// in	: My IP address[31:0]
	EXT_TCP_PORT :	in STD_LOGIC_VECTOR(15 downto 0);--// in	: My TCP main-port #[15:0]
	EXT_RBCP_PORT :	in STD_LOGIC_VECTOR(15 downto 0);--// in	: My UDP RBCP-port #[15:0]
	PHY_ADDR :		in STD_LOGIC_VECTOR(4 downto 0);--// in	: PHY-device MIF address[4:0]
--	// EEPROM
	EEPROM_CS :		out STD_LOGIC;--	,	// out	: Chip select
	EEPROM_SK :		out STD_LOGIC;--	,	// out	: Serial data clock
	EEPROM_DI :		out STD_LOGIC;--	,	// out	: Serial write data
	EEPROM_DO :		in STD_LOGIC;--	,	// in	: Serial read data
--		// user data, intialial values are stored in the EEPROM, 0xFFFF_FC3C-3F
	USR_REG_X3C :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3C
	USR_REG_X3D :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3D
	USR_REG_X3E :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3E
	USR_REG_X3F :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3F
--	// MII interface
	GMII_RSTn :		out STD_LOGIC;--// in	: PHY reset
	GMII_1000M :		in STD_LOGIC;--// in	: GMII mode (0:MII, 1:GMII)
--		// TX
	GMII_TX_CLK :		in STD_LOGIC;--// in	: Tx clock(2.5 or 25MHz)
	GMII_TX_EN :		out STD_LOGIC;--// out	: Tx enable
	GMII_TXD :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Tx data[7:0]
	GMII_TX_ER :		out STD_LOGIC;--// out	: TX error
--		// RX
	GMII_RX_CLK :		in STD_LOGIC;--// in	: Rx clock(2.5 or 25MHz)
	GMII_RX_DV :		in STD_LOGIC;--// in	: Rx data valid
	GMII_RXD :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Rx data[7:0]
	GMII_RX_ER :		in STD_LOGIC;--// in	: Rx error
	GMII_CRS :		in STD_LOGIC;--// in	: Carrier sense
	GMII_COL :		in STD_LOGIC;--// in	: Collision detected
--		// Management IF
	GMII_MDC :		out STD_LOGIC;--// out	: Clock for MDIO
	GMII_MDIO_IN :		in STD_LOGIC;--// in	: Data
	GMII_MDIO_OUT :		out STD_LOGIC;--// out	: Data
	GMII_MDIO_OE :		out STD_LOGIC;--// out	: MDIO output enable
--	// User I/F
	SiTCP_RST :		out STD_LOGIC;--// out	: Reset for SiTCP and related circuits
--		// TCP connection control
	TCP_OPEN_REQ :		in STD_LOGIC;--// in	: Request to connect connection
	TCP_OPEN_ACK :		out STD_LOGIC;--// out	: Acknowledge for open (=Socket busy)
	TCP_ERROR :		out STD_LOGIC;--// out	: TCP error, its active period is equal to MSL
	TCP_CLOSE_REQ :		out STD_LOGIC;--// out	: Connection close
	TCP_CLOSE_ACK :		in STD_LOGIC;--// in	: Acknowledge for close
--		// FIFO I/F
	TCP_RX_WC :		in STD_LOGIC_VECTOR(15 downto 0);--// in	: Fill level[15:0]
	TCP_RX_WR :			out STD_LOGIC;--// out	: Write enable
	TCP_RX_DATA :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Write data[7:0]
	TCP_TX_FULL :		out STD_LOGIC;--// out	: Almost full flag
	TCP_TX_WR :			in STD_LOGIC;--// in	: Write enable
	TCP_TX_DATA :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Write data[7:0]
--		// RBCP
	RBCP_ACT :		out STD_LOGIC;--// out	: RBCP active
	RBCP_ADDR :		out STD_LOGIC_VECTOR(31 downto 0);--// out	: Address[31:0]
	RBCP_WD :			out STD_LOGIC_VECTOR(7 downto 0);--// out	: Data[7:0]
	RBCP_WE :			out STD_LOGIC;--// out	: Write enable
	RBCP_RE :			out STD_LOGIC;--// out	: Read enable
	RBCP_ACK :		in STD_LOGIC;--// in	: Access acknowledge
	RBCP_RD :			in STD_LOGIC_VECTOR(7 downto 0)--// in	: Read data[7:0]
);
end component;
component test_GST_sub
    Port ( clk : in  STD_LOGIC;
	tx_wd : out std_logic_vector(7 downto 0);
	tx_we : out  STD_LOGIC;
	tx_afull : in  STD_LOGIC;
	rx_rd : in std_logic_vector(7 downto 0);
	rx_rv : in  STD_LOGIC;
	rx_re : out  STD_LOGIC;
	rx_empty : in  STD_LOGIC;
	close_req : in  STD_LOGIC;
	close_ack : out  STD_LOGIC;
	active : in  STD_LOGIC);
end component;

	signal iclk, clk0, clkb, locked, ptcp_establish, ptcp_cls_req, tcp_cls_ack : STD_LOGIC;
	signal mdio_in, mdio_out, mdio_oe, c25mhz, clk2p5x, clk2p5xb, reset : STD_LOGIC;
	signal G1000M, int_GMII_TX_CLK, clk0_2, clkb_2, clk3x, clk3xb, locked_2 : STD_LOGIC;
	signal buf1 : STD_LOGIC_VECTOR(7 downto 0);
	signal buf2 : STD_LOGIC_VECTOR(7 downto 0);
	signal ledct, lledct : STD_LOGIC_VECTOR(25 downto 0);
	signal tx_wd, rx_rd : STD_LOGIC_VECTOR(7 downto 0);
	signal tx_we, tx_afull, rx_rv, rx_re, rx_empty : STD_LOGIC;

begin
u0: ibufg port map(I=>clkp, O=>iclk);
u1: DCM_PS generic map(CLKDV_DIVIDE =>2.0, CLKFX_DIVIDE =>2, CLKFX_MULTIPLY => 5)
 port map(clkin=>iclk, clkfb=>clkb, clk0=>clk0, LOCKED=>locked, rst=>'0',
	CLKDV=>c25mhz, CLKFX=>clk2p5x);
u2: bufg port map(I=>clk0, O=>clkb);
u4: bufg port map(I=>clk2p5x, O=>clk2p5xb);
u5 : BUFGMUX port map (
      O => int_GMII_TX_CLK,    -- Clock MUX output
      I0 => GMII_TX_CLK,  -- Clock0 input
      I1 => CLK2p5x,  -- Clock1 input, 125MHz
      S => G1000M     -- Clock select input
   );
G1000M <= not LED_1000Mn;
GMII_MDIO <= mdio_out when mdio_oe='1' else 'Z';
mdio_in <= GMII_MDIO;

u11: DCM_PS generic map(CLKFX_DIVIDE =>1, CLKFX_MULTIPLY => 3)
 port map(clkin=>clkb, clkfb=>clkb_2, clk0=>clk0_2, CLKFX=>clk3x, LOCKED=>locked_2, rst=>not locked);
u12: bufg port map(I=>clk0_2, O=>clkb_2);
u14: bufg port map(I=>clk3x, O=>clk3xb);

--u20: test_GST_sub port map(clk3xb, tx_wd, tx_we, tx_afull,	--very little faster ?
u20: test_GST_sub port map(clkb, tx_wd, tx_we, tx_afull,
	rx_rd, rx_rv, rx_re, rx_empty, ptcp_cls_req, tcp_cls_ack, ptcp_establish);
rx_empty <= not rx_rv;

led(0) <= ptcp_establish or lledct(25);
led(1) <= not LED_1000Mn or ledct(25);
puerom: pullup port map(O=>EEPROM_DO);
MACCLK <= c25mhz;
GMII_GTXCLK <= int_GMII_TX_CLK;	-- CLK2p5x;	--125MHz @50MHz
reset <= not SW_RST or not locked or not locked_2;

--IP address=192.168.0.16, port=24
u30: WRAP_SiTCP_GMII_XC4_32K port map(clk3xb, reset, '1', X"c0a80010", X"0018", X"1234", "00000",
--u30: WRAP_SiTCP_GMII_XC4_32K port map(clkb, reset, '1', X"c0a80010", X"0018", X"1234", "00000",
	EEPROM_CS, EEPROM_SK, EEPROM_DI, EEPROM_DO, open, open, open, open,
	GMII_RSTn ,G1000M , int_GMII_TX_CLK, GMII_TX_EN, GMII_TXD, GMII_TX_ER, GMII_RX_CLK, GMII_RX_DV,
	GMII_RXD, GMII_RX_ER, GMII_CRS, GMII_COL, GMII_MDC, MDIO_IN, MDIO_OUT, MDIO_OE,
	open, '1', ptcp_establish, led(2), ptcp_cls_req, tcp_cls_ack,
	X"0000", rx_rv, rx_rd, tx_afull, tx_we, tx_wd,
	open, open, buf2, open, open, '0', buf2);

process (CLK3xB) 
begin
if CLK3xB='1' and CLK3xB'event then
	ledct <= ledct+1;
end if;
end process;

process (CLKb) 
begin
if CLKb='1' and CLKb'event then
	lledct <= lledct+1;
end if;
end process;

end Behavioral;

